diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe.c openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe.c
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe.c	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,216 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+#include <stdio.h>
+#include <stdint.h>
+#include <string.h>
+#include <stdlib.h>
+
+#include "fft.h"
+#include "rlwe.h"
+
+#include "rlwe_table.h"
+
+#define setbit(a,x) ((a)[(x)/64] |= (((uint64_t) 1) << (uint64_t) ((x)%64)))
+#define getbit(a,x) (((a)[(x)/64] >> (uint64_t) ((x)%64)) & 1)
+#define clearbit(a,x) ((a)[(x)/64] &= ((~((uint64_t) 0)) - (((uint64_t) 1) << (uint64_t) ((x)%64))))
+
+#define RANDOM192(c) c[0] = RANDOM64; c[1] = RANDOM64; c[2] = RANDOM64
+
+/* Returns 0 if a >= b
+ * Returns 1 if a < b
+ * Where a and b are both 3-limb 64-bit integers.
+ * This function runs in constant time.
+ */
+static int cmplt_ct(uint64_t *a, uint64_t *b) {
+	int m;
+	m = (a[0] >= b[0]);
+	m = ((a[1] >= b[1]) && (!(a[1] == b[1]) || m));
+	m = ((a[2] >= b[2]) && (!(a[2] == b[2]) || m));
+	return (m == 0);
+}
+
+static uint32_t single_sample(uint64_t *in) {
+	uint32_t lower_index = 0, this_index = 32, upper_index = 64;
+	int i;
+	for (i = 0; i < 6; i++) {
+		if (cmplt_ct(in, rlwe_table[this_index])) {
+			upper_index = this_index;
+		} else {
+			lower_index = this_index;
+		}
+		this_index = (lower_index + upper_index) / 2;
+	}
+	return lower_index;
+}
+
+/* Constant time version. */
+static uint32_t single_sample_ct(uint64_t *in) {
+	uint32_t index = 0, i;
+
+	for (i = 0; i < 52; i++) {
+		uint32_t mask1, mask2;
+		mask1 = cmplt_ct(in, rlwe_table[i]);
+		mask1 = (uint32_t) (0 - (int32_t) mask1);
+		mask2 = (~mask1);
+		index = ((index & mask1) | (i & mask2));
+	}
+	return index;
+}
+
+void sample_ct(uint32_t *s) {
+	RANDOM_VARS
+	int i, j;
+	for (i = 0; i < 16; i++) {
+		uint64_t r = RANDOM64;
+		for (j = 0; j < 64; j++) {
+			uint64_t rnd[3];
+			int32_t m;
+			uint32_t t;
+			RANDOM192(rnd);
+			m = (r & 1);
+			r >>= 1;
+			m = 2 * m - 1;
+			// use the constant time version single_sample
+			s[i * 64 + j] = single_sample_ct(rnd);
+			t = 0xFFFFFFFF - s[i * 64 + j];
+			s[i * 64 + j] = ((t & (uint32_t) m) | (s[i * 64 + j] & (~((uint32_t) m))));
+		}
+	}
+}
+
+void sample(uint32_t *s) {
+	RANDOM_VARS
+	int i, j;
+	for (i = 0; i < 16; i++) {
+		uint64_t r = RANDOM64;
+		for (j = 0; j < 64; j++) {
+			uint64_t rnd[3];
+			int32_t m;
+			RANDOM192(rnd);
+			m = (r & 1);
+			r >>= 1;
+			m = 2 * m - 1;
+			s[i * 64 + j] = single_sample(rnd);
+			if (m == -1) {
+				s[i * 64 + j] = 0xFFFFFFFF - s[i * 64 + j];
+			}
+		}
+	}
+}
+
+void round2(uint64_t *out, const uint32_t *in) {
+	int i;
+
+	// out should have enough space for 1024-bits
+	memset(out, 0, 128);
+
+	//q/4 and 3*q/4
+	for (i = 0; i < 1024; i++) {
+		if (in[i] >= 1073741824 && in[i] <= 3221225471) {
+			setbit(out, i);
+		}
+	}
+}
+
+/* Constant time version. */
+void round2_ct(uint64_t *out, const uint32_t *in) {
+	int i;
+	memset(out, 0, 128);
+	for (i = 0; i < 1024; i++) {
+		uint32_t b = (in[i] >= 1073741824 && in[i] <= 3221225471);
+		out[i / 64] |= (((uint64_t) b) << (uint64_t) (i % 64));
+	}
+}
+
+/* We assume that e contains two random bits in the two
+ * least significant positions. */
+uint64_t dbl(const uint32_t in, int32_t e) {
+	// sample uniformly from [-1, 0, 0, 1]
+	// Hence, 0 is sampled with twice the probability of 1
+	e = (((e >> 1) & 1) - ((int32_t) (e & 1)));
+	return (uint64_t) ((((uint64_t) in) << (uint64_t) 1) - e);
+}
+
+void crossround2(uint64_t *out, const uint32_t *in) {
+	int i, j;
+	RANDOM_VARS
+	// out should have enough space for 1024-bits
+	memset(out, 0, 128);
+
+	for (i = 0; i < 64; i++) {
+		uint32_t e = RANDOM32;
+		for (j = 0; j < 16; j++) {
+			uint64_t dd = dbl(in[i * 16 + j], (int32_t) e);
+			e >>= 2;
+			//q/2 to q and 3*q/2 to 2*q
+			if ((dd >= (uint64_t) 2147483648 && dd <= (uint64_t) 4294967295) || (dd >= (uint64_t) 6442450942 && dd <= (uint64_t) 8589934590)) {
+				setbit(out, (i * 16 + j));
+			}
+		}
+	}
+}
+
+void crossround2_ct(uint64_t *out, const uint32_t *in) {
+	RANDOM_VARS
+	int i, j;
+	memset(out, 0, 128);
+	for (i = 0; i < 64; i++) {
+		uint32_t e = RANDOM32;
+		for (j = 0; j < 16; j++) {
+			uint64_t dd;
+			uint32_t b;
+			dd = dbl(in[i * 16 + j], (int32_t) e);
+			e >>= 2;
+			b = ((dd >= (uint64_t) 2147483648 && dd <= (uint64_t) 4294967295) || (dd >= (uint64_t) 6442450942 && dd <= (uint64_t) 8589934590));
+			out[(i * 16 + j) / 64] |= (((uint64_t) b) << (uint64_t) ((i * 16 + j) % 64));
+		}
+	}
+}
+
+void rec(uint64_t *out, const uint32_t *w, const uint64_t *b) {
+	int i;
+
+	// out should have enough space for 1024-bits
+	memset(out, 0, 128);
+
+	for (i = 0; i < 1024; i++) {
+		uint64_t coswi = (((uint64_t) w[i]) << (uint64_t) 1);
+		if (getbit(b, i) == 0) {
+			//Ceiling(2*3*q/8)..Floor(2*7*q/8)
+			if (coswi >= (uint64_t) 3221225472 && coswi <= (uint64_t) 7516192766) {
+				setbit(out, i);
+			}
+		} else {
+			// Ceiling(2*q/8)..Floor(2*5*q/8)
+			if (coswi >= (uint64_t) 1073741824 && coswi <= (uint64_t) 5368709118) {
+				setbit(out, i);
+			}
+		}
+	}
+}
+
+void rec_ct(uint64_t *out, const uint32_t *w, const uint64_t *b) {
+	int i;
+	memset(out, 0, 128);
+	for (i = 0; i < 1024; i++) {
+		uint64_t coswi;
+		uint32_t B;
+		coswi = (((uint64_t) w[i]) << (uint64_t) 1);
+		B = ((getbit(b, i) == 0 && coswi >= (uint64_t) 3221225472 && coswi <= (uint64_t) 7516192766) || (getbit(b, i) == 1 && coswi >= (uint64_t) 1073741824 && coswi <= (uint64_t) 5368709118));
+		out[i / 64] |= (((uint64_t) B) << (uint64_t) (i % 64));
+	}
+}
+
+void key_gen(uint32_t *out, const uint32_t *a, const uint32_t *s, const uint32_t *e, FFT_CTX *ctx) {
+	FFT_mul(out, a, s, ctx);
+	FFT_add(out, out, e);
+}
+
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,36 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+#ifndef _RLWE_H_
+#define _RLWE_H_
+
+#include <stdint.h>
+
+#include "fft.h"
+
+void sample_ct(uint32_t *s);
+void sample(uint32_t *s);
+
+void round2_ct(uint64_t *out, const uint32_t *in);
+void round2(uint64_t *out, const uint32_t *in);
+
+/* We assume that e contains two random bits in the two
+ * least significant positions. */
+uint64_t dbl(const uint32_t in, int32_t e);
+
+void crossround2_ct(uint64_t *out, const uint32_t *in);
+void crossround2(uint64_t *out, const uint32_t *in);
+
+void rec_ct(uint64_t *out, const uint32_t *w, const uint64_t *b);
+void rec(uint64_t *out, const uint32_t *w, const uint64_t *b);
+
+void key_gen(uint32_t *out, const uint32_t *a, const uint32_t *s, const uint32_t *e, FFT_CTX *ctx);
+
+#endif /* _RLWE_H_ */
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe_a.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe_a.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe_a.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe_a.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,268 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+uint32_t rlwe_a[1024] = {
+	0x29FE0191, 0xDD1A457D, 0x3534EE4B, 0x6450ED74,
+	0xBBFE9F64, 0x92BF0F31, 0x8DCF8995, 0x4C5E30D0,
+	0x9E2ED04D, 0x8C18FE0B, 0x1A70F2E7, 0x2625CD93,
+	0x0065DA14, 0x6E009722, 0xE6A70E8B, 0xAEF6EF56,
+	0x8C6C06AF, 0x9E59E953, 0x4995F67B, 0xE918EE9D,
+	0x8B4F41A7, 0x0D811041, 0xF5FE6458, 0x3C02B584,
+	0xCBCFC8FD, 0x5A01F116, 0x73408361, 0x44D3A098,
+	0xBBDEECF6, 0x90E09082, 0xF8538BA4, 0xF9600091,
+	0xD8D30FEF, 0x56201487, 0xACB2159D, 0x38F47F77,
+	0xED7A864F, 0x8FC785CA, 0x7CBD6108, 0x3CA577DE,
+	0xFF44CCC2, 0xA1385A79, 0x5C88E3AD, 0x177C46A9,
+	0xDA4A4DD8, 0x2AA3594F, 0xA4A5E629, 0x47CA6F6E,
+	0xB2DF1BC6, 0x6841B78E, 0x0823F5A8, 0xA18C7D52,
+	0x7634A0D1, 0xDA1751BA, 0x18B9D25D, 0x5B2643BC,
+	0xACC6975D, 0x48E786F4, 0x05E3ED4E, 0x4DC86568,
+	0x3F5C5F99, 0x585DBFD7, 0xEF6E0715, 0x7D36B823,
+	0x12D872CD, 0xD7B78F27, 0xDD672BF5, 0x2DC7C7EB,
+	0xA3033801, 0x50E48348, 0x9162A260, 0x0BE8F15B,
+	0xABB563EC, 0x06624C5A, 0x812BF7BC, 0x8637AC35,
+	0xF44504F3, 0xFF8577AB, 0x4A0161B0, 0x000AEB0E,
+	0x311204AF, 0x2A76831B, 0x4D903F3A, 0x97204FA9,
+	0x9EB524E3, 0x1757AFAC, 0xBA369FEC, 0xCD8F198D,
+	0x6B33C246, 0x51C13FCE, 0xB58ACC4E, 0x39ACF8DA,
+	0x7BB7EBF7, 0xEDC1449D, 0xC7B47FDB, 0x9C39148D,
+	0x4E688D7B, 0xFAD0C2C2, 0x296CE85C, 0x6045C89C,
+	0x6441C0C6, 0x50C7C83A, 0xC11764DD, 0x58D7EEA2,
+	0xE57B9D0E, 0x4E142770, 0xB8BFBB59, 0xE143EBAA,
+	0xFF60C855, 0x238727F0, 0xE35B4A5B, 0x8F96940B,
+	0x4498A6BA, 0x5911093A, 0x394DD002, 0x521B00D2,
+	0x140BDAF9, 0xEAB67207, 0x21E631A6, 0xA04AADA9,
+	0xA96A9843, 0x4B44CC9B, 0xE4D24C33, 0xC7E7AE78,
+	0xE45A6C72, 0xCBE61D3C, 0xCE5A4869, 0x10442A52,
+	0xDB11F194, 0x39FC415D, 0x7E7BDB76, 0xAE9EFA22,
+	0x25F4F262, 0x472DD0A7, 0x42EBD7A0, 0xE8038ECE,
+	0xD3DB002A, 0x8416D2EC, 0xDF88C989, 0x7FEA22D5,
+	0xC7A3F6FE, 0x37409982, 0xF45B75E2, 0x9A4AC289,
+	0x90406FD6, 0xEA1C74A5, 0x5777B39F, 0xD07F1FA3,
+	0xCE6EDA0D, 0xD150ECFB, 0xBEFF71BA, 0x50129EFC,
+	0x51CE65B9, 0xB9FB0AB8, 0x770C59CB, 0x11F2354F,
+	0x8623D4BB, 0xD6FCAFD6, 0xB2B1697C, 0x0D7067E2,
+	0x2BA5AFB9, 0xD369C585, 0x5B5E156C, 0xD8C81E6E,
+	0x80CFDF16, 0xF6F441EB, 0xC173BAF5, 0x78099E3A,
+	0xD38F027B, 0x4AC8D518, 0x8D0108A1, 0xE442B0F1,
+	0x56F9EA3C, 0xD0D6BBCA, 0x4E17DCB4, 0x69BF743B,
+	0x0CCE779F, 0xD5E59851, 0x63861EA2, 0xB1CB22C1,
+	0xBBFD2ACE, 0xDDA390D1, 0xEDF1059F, 0x04F80F89,
+	0xB13AF849, 0x58C66009, 0xE0D781C0, 0x588DC348,
+	0xA305669D, 0x0D7AF67F, 0x32BC3C38, 0xD725EFBA,
+	0xDC3D9434, 0x22BD7ED8, 0x2DFD2926, 0x4BDEAD3A,
+	0xB2D5ECE6, 0x16B05C99, 0xFEEC7104, 0xF6CAC918,
+	0x0944C774, 0xCE00633B, 0xC59DA01A, 0x41E8E924,
+	0x335DF501, 0x3049E8EE, 0x5B4B8AAC, 0xC962FC91,
+	0xD6BB22B3, 0x0AC870EB, 0xC3D99400, 0xA0CEAC28,
+	0xAF07DE1E, 0x831C2824, 0x258C5DDC, 0x779417E6,
+	0x41CB33D0, 0x4E51076A, 0xD1DB6038, 0x9E0B1C41,
+	0xA9A1F90D, 0xF27E7705, 0x75892711, 0x5D9F1175,
+	0x85CC508B, 0x5CA415BE, 0x1858C792, 0xFB18632F,
+	0xC94111EB, 0x937C0D28, 0xC2A09970, 0x386209D9,
+	0xBBDD9787, 0x2473F53A, 0xEF7E7637, 0xCFC8630B,
+	0x2BA3B7F8, 0x3C0047AD, 0x10D76FF7, 0xB1D9414D,
+	0xCEB7B902, 0xA5B543F5, 0x2E484905, 0xE0233C10,
+	0xD061A1F8, 0xCED0A901, 0xAC373CAC, 0x04281F37,
+	0x3609797F, 0xDB80964D, 0x7B49A74F, 0x7699656F,
+	0x0DCEC4BC, 0x0EC49C2D, 0xF1573A4E, 0xA3708464,
+	0x9A1E89F0, 0x6B26DEB6, 0x2329FA10, 0xCA4F2BFF,
+	0x9E012C8E, 0x788C1DFD, 0x2C758156, 0x2774C544,
+	0x150A1F7D, 0x50156D6E, 0x7B675DE1, 0x5D634703,
+	0xA7CEB801, 0x92733DAB, 0xB213C00B, 0x304A65B1,
+	0x8856CF8E, 0x7FF7DD67, 0xD0912293, 0x30064297,
+	0x663D051D, 0x01BC31B4, 0x2B1700BD, 0x39D7D18F,
+	0x1EAD5C95, 0x6FB9CD8B, 0xA09993A6, 0xB42071C0,
+	0x3C1F2195, 0x7FDF4CF8, 0xC7565A7E, 0x64703D34,
+	0x14B250EF, 0x2FA338D2, 0xAEE576DC, 0x6CCED41D,
+	0x612D0913, 0xD0680733, 0x8B4DBE8A, 0x6FFEA3D0,
+	0x46197CA2, 0xA77F916F, 0xFA5D7BD6, 0x01E22AEB,
+	0x18E462DD, 0x4EC9B937, 0xDE753212, 0x05113C94,
+	0x7786FBD4, 0xFB379F71, 0x756CF595, 0xEAADCFAB,
+	0xBBD74C2E, 0x1F234AC9, 0x85E28AEB, 0x329F7878,
+	0xD48FDE09, 0x47A60D0A, 0xAE95163F, 0x72E70995,
+	0x27F9FCBF, 0xBDCFCC41, 0x334BC498, 0xEE7931A1,
+	0xDFA6AEF4, 0x1EC5E1BF, 0x6221870F, 0xCD54AE13,
+	0x7B56EF58, 0x4847B490, 0x31640CD3, 0x10940E14,
+	0x556CC334, 0xC9E9B521, 0x499611FF, 0xBEC8D592,
+	0x44A7DCB7, 0x4AC2EABD, 0x7D387357, 0x1B76D4B6,
+	0x2EACE8C9, 0x52B2D2A4, 0x0C1F2A64, 0x50EF2B9A,
+	0x3B23F4F4, 0x8DDE415E, 0xF6B92D2D, 0x9DB0F840,
+	0xE18F309D, 0x737B7733, 0xF9F563C5, 0x3C5D4AEE,
+	0x8136B0AF, 0xC5AC5550, 0x6E93DEF9, 0x946BCCEC,
+	0x5163A273, 0xB5C72175, 0x4919EFBD, 0x222E9B68,
+	0x6E43D8EE, 0xAA039B23, 0x913FD80D, 0x42206F18,
+	0x5552C01F, 0x35B1136D, 0xFDC18279, 0x5946202B,
+	0xFAAE3A37, 0x4C764C88, 0x78075D9B, 0x844C8BA0,
+	0xCC33419E, 0x4B0832F6, 0x10D15E89, 0xEE0DD05A,
+	0x27432AF3, 0xE12CECA6, 0x60A231B3, 0xF81F258E,
+	0xE0BA44D7, 0x144F471B, 0xB4C8451E, 0x3705395C,
+	0xE8A69794, 0x3C23F27E, 0x186D2FBA, 0x3DAED36B,
+	0xF04DEFF1, 0x0CFA7BDD, 0xFEE45A4F, 0x5E9A4684,
+	0x98438C69, 0x5F1D921B, 0x7E43FD86, 0xBD0CF049,
+	0x28F47D38, 0x7DF38246, 0x8EED8923, 0xE524E7FC,
+	0x089BEC03, 0x15E3DE77, 0x78E8AE28, 0xCB79A298,
+	0x9F604E2B, 0x3C6428F7, 0xDCDEABF3, 0x33BAF60A,
+	0xBF801273, 0x247B0C3E, 0xE74A8192, 0xB45AC81D,
+	0xFC0D2ABE, 0xF17E99F5, 0x412BD1C1, 0x75DF4247,
+	0xA90FC3C0, 0xB2A99C0E, 0x0D3999D7, 0xD04543BA,
+	0x0FBC28A1, 0xEF68C7EF, 0x64327F30, 0xF11ECDBE,
+	0x4DBD312C, 0xD71CE03A, 0xAEFDAD34, 0xE1CC7315,
+	0x797A865C, 0xB9F1B1EB, 0xF7E68DFA, 0x816685B4,
+	0x9F38D44B, 0x366911C8, 0x756A7336, 0x696B8261,
+	0xC2FA21D2, 0x75085BF3, 0x2E5402B4, 0x75E6E744,
+	0xEAD80B0C, 0x4E689F68, 0x7A9452C6, 0xA5E1958A,
+	0x4B2B0A24, 0x97E0165E, 0xA4539B68, 0xF87A3096,
+	0x6543CA9D, 0x92A8D398, 0xA7D7FDB4, 0x1EA966B3,
+	0x75B50372, 0x4C63A778, 0x34E8E033, 0x87C60F82,
+	0xFC47303B, 0x8469AB86, 0x2DAADA50, 0xCFBB663F,
+	0x711C9C41, 0xE6C1C423, 0x8751BAA9, 0x861EC777,
+	0x31BCCCE1, 0xC1333271, 0x06864BEE, 0x41B50595,
+	0xD2267D30, 0x878BA5C5, 0x65267F56, 0x2118FB18,
+	0xA6DDD3DE, 0x8D309B98, 0x68928CB2, 0xFAE967DC,
+	0x3CEC52D0, 0x9CA8404B, 0xAADD68A8, 0x3AC6B1DF,
+	0xD53D67EA, 0x95C8D163, 0xB5F03F1D, 0x3A4C28A7,
+	0xE3C4B709, 0xB8EB7C65, 0xE76B42A3, 0x25E5A217,
+	0x6B6DD2B4, 0xBEFC5DF4, 0x9ACA5758, 0xC17F14D3,
+	0xB224A9D3, 0xDE1A7C8F, 0x1382911B, 0x627A2FB9,
+	0xC66AE36E, 0x02CC60EF, 0xC6800B20, 0x7A583C77,
+	0xE1CECEE8, 0xCA0001B4, 0x6A14CF16, 0xEF45DD21,
+	0x64CAA7D5, 0xFF3F1D95, 0xD328C67E, 0xC85868B1,
+	0x7FBF3FEB, 0x13D68388, 0x25373DD9, 0x8DE47EFB,
+	0x47912F26, 0x65515942, 0xC5ED711D, 0x6A368929,
+	0xA2405C50, 0xFFA9D6EB, 0xED39A0D4, 0xE456B8B5,
+	0x53283330, 0x7837FD52, 0x6EE46629, 0xCAFC9D63,
+	0xB781B08F, 0xDD61D834, 0xFB9ACF09, 0xEDA4444A,
+	0xBB6AA57F, 0xAED2385C, 0x22C9474D, 0x36E90167,
+	0xE6DF6150, 0xF1B0DA3B, 0xC3F6800E, 0x966302E0,
+	0x7DB1F627, 0xF9632186, 0xB4933075, 0x81C5C817,
+	0x878CA140, 0x4EDE8FED, 0x1AF347C1, 0xFDEB72BA,
+	0x2DA7FF9A, 0xB9BA3638, 0x2BB883F1, 0x474D1417,
+	0xC2F474A4, 0x1E2CF9F3, 0x231CB6B0, 0x7E574B53,
+	0xEDA8E1DA, 0xE1ACB7BB, 0xD1E354A6, 0x7C32B431,
+	0x8189991B, 0x25F9376A, 0x3FFA8782, 0xCD9038F1,
+	0x119EDBD1, 0x5C571840, 0x3DCA350F, 0x83923909,
+	0x9DC3CF55, 0x94D79DD0, 0xD683DE2B, 0xECF4316A,
+	0x0FFF48D4, 0x5D8076ED, 0x12B42C97, 0x2284CDB4,
+	0xCB245554, 0x3025B4D9, 0xB0075F35, 0x43A3802E,
+	0x18332B4D, 0x056C4467, 0xC597E3F7, 0x3F0EAF9D,
+	0xF48EBB9F, 0x92F62731, 0xBDB76296, 0x516D4466,
+	0x226102B3, 0x15E38046, 0xA683C4E0, 0x6C0D1962,
+	0xE20CB6CA, 0xC90C1D70, 0xD0FF8692, 0xD1419690,
+	0x2D6F1081, 0x34782E5E, 0xAE092CD5, 0x90C99193,
+	0xE97C0405, 0xEAE201DA, 0x631FB5AC, 0x279A2821,
+	0xDF47BA5B, 0xFBE587E2, 0x6810AD2D, 0xC63E94BD,
+	0x9AF36B42, 0xF14F0855, 0x946CE350, 0x7E3320E0,
+	0x34130DFF, 0x8C57C413, 0xAB0723B2, 0xF514C743,
+	0x63694BA3, 0x5665D23D, 0x6292C0B5, 0x9D768323,
+	0x2F8E447C, 0xB99A00FB, 0x6F8E5970, 0x69B3BB45,
+	0x59253E02, 0x1C518A02, 0xDD7C1232, 0xC6416C38,
+	0x77E10340, 0xCF6BEB9A, 0x006F9239, 0x0E99B50F,
+	0x863AD247, 0x75F0451A, 0x096E9094, 0xE0C2B357,
+	0x7CC81E15, 0x222759D4, 0xEE5BCFD0, 0x050F829B,
+	0x723B8FA9, 0x76143C55, 0x3B455EAF, 0xC2683EFD,
+	0xEE7874B4, 0x9BCE92F7, 0x6EED7461, 0x8E93898F,
+	0xA4EBE1D0, 0xFA4F019F, 0x1B0AD6DA, 0xA39CDE2F,
+	0x27002B33, 0x830D478D, 0x3EEA937E, 0x572E7DA3,
+	0x4BFFA4D1, 0x5E53DB0B, 0x708D21EE, 0xB003E23B,
+	0x12ED0756, 0x53CA0412, 0x73237D35, 0x438EC16B,
+	0x295177B8, 0xC85F4EE6, 0xB67FD3B4, 0x5221BC81,
+	0xD84E3094, 0x18C84200, 0x855E0795, 0x37BEC004,
+	0xDF9FAFC9, 0x60BEB6CD, 0x8645F0C5, 0xB1D2F1C3,
+	0xECDC4AE3, 0x424D17F1, 0x8429238C, 0x6155EAAB,
+	0xA17BEE21, 0x218D3637, 0x88A462CC, 0x8A1A031E,
+	0x3F671EA5, 0x9FA08639, 0xFF4A0F8E, 0x34167A7D,
+	0x1A817F54, 0x3215F21E, 0x412DD498, 0x57B633E7,
+	0xE8A2431F, 0x397BD699, 0x5A155288, 0xBB3538E8,
+	0xA49806D2, 0x49438A07, 0x24963568, 0x40414C26,
+	0xE45C08D4, 0x61D2435B, 0x2F36AEDE, 0x6580370C,
+	0x02A56A5E, 0x53B18017, 0xAF2C83FC, 0xF4C83871,
+	0xD9E5DDC3, 0x17B90B01, 0xED4A0904, 0xFA6DA26B,
+	0x35D9840D, 0xA0C505E4, 0x3396D0B5, 0xEC66B509,
+	0xC190E41C, 0x2F0CE5CF, 0x419C3E94, 0x220D42CA,
+	0x2F611F4F, 0x47906734, 0x8C2CDB17, 0xD8658F1C,
+	0x2F6745CD, 0x543D0D4F, 0x818F0469, 0x380FFDAE,
+	0xF5DD91E2, 0xAD25E46A, 0xE7039205, 0xA9F47165,
+	0xB2114C12, 0xCF7F626F, 0x54D2C9FF, 0xE4736A36,
+	0x16DB09FC, 0xE2B787BB, 0x9631709A, 0x72629F66,
+	0x819EBA08, 0x7F5D73F3, 0xA0B0B91C, 0xFEDFBA71,
+	0x252F14EE, 0xF26F8FA2, 0x92805F94, 0x43650F7F,
+	0x3051124F, 0x72CA8EAD, 0x21973E34, 0xA5B70509,
+	0xB36A41CC, 0xC52EDE5F, 0xF706A24E, 0x8AAF9F92,
+	0xADF6D99A, 0x23746D73, 0x1DA39F70, 0x9660FC8F,
+	0xA0A8CFEB, 0x83D5EFCA, 0x0AA4A72F, 0xEEF1B2DE,
+	0x00CFCC66, 0x8A145369, 0x6376CEDA, 0xA3262E2E,
+	0x3367BBA8, 0x01488C32, 0x5561A2AD, 0x40821BF2,
+	0xF0C89F61, 0xC4FAA6B3, 0xD843377A, 0x67A76555,
+	0xE8D9F1CE, 0x943034FF, 0x2BD468BD, 0xA514D935,
+	0x50CDB19D, 0xA09C7E9E, 0x6FEBEC30, 0xB1B36CF7,
+	0xCD7A30BC, 0x36C6FE0A, 0x2DF52C45, 0x45C9957F,
+	0x65076A79, 0xBF783DEE, 0x718D37F0, 0x098F9117,
+	0x9A70C430, 0x80EB1A53, 0x9F2505B1, 0x48D10D98,
+	0xB8D781E9, 0xF2376133, 0xECF25B98, 0x5A3B0E18,
+	0x2F623537, 0x9F0E34A4, 0xF1027EB6, 0xF9B16022,
+	0xBA3FEC59, 0xEF7226FD, 0x9F3058AA, 0xBB51DE0E,
+	0xD5435EA0, 0x8A6479D5, 0x077708B8, 0x9634876A,
+	0x069A260A, 0x168D9E6A, 0x9FD18E94, 0x8A7ACD53,
+	0x8E5A5869, 0x1B6F35FD, 0xA968913B, 0xC72F076B,
+	0x7DDA354C, 0x25B0297C, 0xD07219D5, 0xA66862BA,
+	0x87E8EE67, 0xFA28809B, 0x55762443, 0x31EF4956,
+	0xF4F4A511, 0x9A9378CB, 0x42ABDBDE, 0x7AA484B7,
+	0xE8EC22ED, 0xCADDEF61, 0x9D18538A, 0xA81B923E,
+	0x9C32F92A, 0x6D278E58, 0x4CDFC716, 0xAB64814F,
+	0xF832BF1A, 0xE2C1A36B, 0x20675610, 0xE78D855A,
+	0x38332C3D, 0x5AE0EAD9, 0x2E23F22D, 0x3C8683C5,
+	0xA351AF89, 0x54720D3B, 0xABC6E51F, 0x89330C8E,
+	0x600D5650, 0x197EA0C6, 0x7D502A5D, 0x3A536EA7,
+	0x7DF71F32, 0x456FE645, 0x3EF5E7A2, 0x6664BCAF,
+	0xA9D074C2, 0xE9D9E478, 0x1AE9AB77, 0xFECE7160,
+	0xC618EEEC, 0x771B0026, 0x2B54F43C, 0x145DA102,
+	0x1B3D7949, 0xBB6E2D9D, 0xDB8FDC4A, 0x25397EBA,
+	0x9228A6E9, 0x56B4C69D, 0x337B943C, 0xE35B716C,
+	0xF7FE89A1, 0x023AC20D, 0x033165C8, 0x9F13B130,
+	0xC1BAFB1D, 0xA2C42C8C, 0x58E4D431, 0xE10741E6,
+	0x2547589A, 0x8D9EF7BD, 0x7E322280, 0xF49FDDC2,
+	0xBE21A094, 0xA061178A, 0x34D9F13B, 0x694D652F,
+	0x05084A2A, 0x2767B991, 0xE8536AB4, 0xEBFADF6F,
+	0xF4C8DFAC, 0xD9967CCA, 0xE04BCF3F, 0x232B3460,
+	0x9FF6E88A, 0x6DF3A2B0, 0x0FE10E99, 0x7B059283,
+	0x067BFB57, 0x8DDA26B0, 0xB7D6652F, 0x85705248,
+	0x0826240C, 0x5DF7F52E, 0x47973463, 0xB9C22D37,
+	0x9BEB265D, 0x493AB6FD, 0x10C0FB07, 0x947C102A,
+	0x5FEC0608, 0x140E07AE, 0x8B330F43, 0x9364A649,
+	0xC9AD63EF, 0xBE4B2475, 0x1A09AC77, 0x9E40A4B0,
+	0xBA9C23E7, 0x7F4A798D, 0xE2C52D66, 0xA26EE9E0,
+	0x8C79DCE7, 0xDD7F1C3D, 0x6AE83B20, 0x073DBA03,
+	0xB1844D97, 0x16D7ED6E, 0x5E0DE0B1, 0xA497D717,
+	0xFA507AA2, 0xC332649B, 0x21419E15, 0x384D9CCC,
+	0x8B915A8B, 0xBA328FD5, 0xF99E8016, 0x545725EC,
+	0xED9840ED, 0x71E5D78A, 0x21862496, 0x6F858B6C,
+	0xF3736AE2, 0x8979FC2B, 0x5C8122D0, 0x0A20EB5A,
+	0x2278AA6E, 0x55275E74, 0x22D57650, 0xE5FFDC96,
+	0x6BA86E10, 0x4EC5BFCC, 0x05AFA305, 0xFB7FD007,
+	0x726EA097, 0xF6A349C4, 0xCB2F71E4, 0x08DD80BA,
+	0x892D0E23, 0xBD2E0A55, 0x40AC0CD3, 0xBFAF5688,
+	0x6E40A6A5, 0x6DA1BBE0, 0x969557A9, 0xFB88629B,
+	0x11F845C4, 0x5FC91C6F, 0x1B0C7E79, 0xD6946953,
+	0x27A164A0, 0x55D20869, 0x29A2182D, 0x406AA963,
+	0x74F40C59, 0x56A90570, 0x535AC9C6, 0x9521EF76,
+	0xBA38759B, 0xCD6EF76E, 0xF2181DB9, 0x7BE78DA6,
+	0xF88E4115, 0xABA7E166, 0xF60DC9B3, 0xFECA1EF3,
+	0x43DF196A, 0xCC4FC9DD, 0x428A8961, 0xCF6B4560,
+	0x87B30B57, 0x20E7BAC5, 0xBFBDCCDF, 0xF7D3F6BB,
+	0x7FC311C8, 0x2C7835B5, 0xA24F6821, 0x6A38454C,
+	0x460E42FD, 0x2B6BA832, 0xC7068C72, 0x28CDCE59,
+	0xAE82A0B4, 0x25F39572, 0x9B6C7758, 0xE0FE9EBA,
+	0xA8F03EE1, 0xD70B928E, 0x95E529D7, 0xDD91DB86,
+	0xF912BA8C, 0x7F478A6A, 0x1F017850, 0x5A717E10,
+	0xDAC243F9, 0xD235F314, 0x4F80AAE6, 0xA46364D8,
+	0xA1E3A9E9, 0x495FEFB1, 0xB9058508, 0x23A20999,
+	0x73D18118, 0xCA3EEE2A, 0x34E1C7E2, 0xAADBADBD
+};
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe_table.h openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe_table.h
--- openssl-1.0.1f/crypto/rlwekex/rlwekexlib/rlwe_table.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekexlib/rlwe_table.h	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,64 @@
+/* This is free and unencumbered software released into the public domain.
+ *
+ * Anyone is free to copy, modify, publish, use, compile, sell, or
+ * distribute this software, either in source code form or as a compiled
+ * binary, for any purpose, commercial or non-commercial, and by any
+ * means.
+ *
+ * See LICENSE for complete information.
+ */
+
+static uint64_t rlwe_table[52][3] = {
+	{0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF, 0x1FFFFFFFFFFFFFFF},
+	{0xE0C81DA0D6A8BD22, 0x161ABD186DA13542, 0x5CEF2C248806C827},
+	{0x8D026C4E14BC7408, 0x4344C125B3533F22, 0x9186506BCC065F20},
+	{0x10AC7CEC7D7E2A3B, 0x5D62CE65E6217813, 0xBAAB5F82BCDB43B3},
+	{0x709C92996E94D801, 0x1411F551608E4D22, 0xD7D9769FAD23BCB1},
+	{0x6287D827008404B7, 0x7E1526D618902F20, 0xEA9BE2F4D6DDB5ED},
+	{0x34CBDC118C15F40E, 0xE7D2A13787E94674, 0xF58A99474919B8C9},
+	{0xD521F7EBBBE8C3A2, 0xE8A773D9A1EA0AAB, 0xFB5117812753B7B8},
+	{0xC3D9E58131089A6A, 0x148CB49FF716491B, 0xFE151BD0928596D3},
+	{0x2E060C4A842A27F6, 0x07E44D009ADB0049, 0xFF487508BA9F7208},
+	{0xFCEDEFCFAA887582, 0x1A5409BF5D4B039E, 0xFFC16686270CFC82},
+	{0x4FE22E5DF9FAAC20, 0xFDC99BFE0F991958, 0xFFEC8AC3C159431B},
+	{0xA36605F81B14FEDF, 0xA6FCD4C13F4AFCE0, 0xFFFA7DF4B6E92C28},
+	{0x9D1FDCFF97BBC957, 0x4B869C6286ED0BB5, 0xFFFE94BB4554B5AC},
+	{0x6B3EEBA74AAD104B, 0xEC72329E974D63C7, 0xFFFFAADE1B1CAA95},
+	{0x48C8DA4009C10760, 0x337F6316C1FF0A59, 0xFFFFEDDC1C6436DC},
+	{0x84480A71312F35E7, 0xD95E7B2CD6933C97, 0xFFFFFC7C9DC2569A},
+	{0x23C01DAC1513FA0F, 0x8E0B132AE72F729F, 0xFFFFFF61BC337FED},
+	{0x90C89D6570165907, 0x05B9D725AAEA5CAD, 0xFFFFFFE6B3CF05F7},
+	{0x692E2A94C500EC7D, 0x99E8F72C370F27A6, 0xFFFFFFFC53EA610E},
+	{0x28C2998CEAE37CC8, 0xC6E2F0D7CAFA9AB8, 0xFFFFFFFF841943DE},
+	{0xC515CF4CB0130256, 0x4745913CB4F9E4DD, 0xFFFFFFFFF12D07EC},
+	{0x39F0ECEA047D6E3A, 0xEE62D42142AC6544, 0xFFFFFFFFFE63E348},
+	{0xDF11BB25B50462D6, 0x064A0C6CC136E943, 0xFFFFFFFFFFD762C7},
+	{0xCDBA0DD69FD2EA0F, 0xC672F3A74DB0F175, 0xFFFFFFFFFFFC5E37},
+	{0xFDB966A75F3604D9, 0x6ABEF8B144723D83, 0xFFFFFFFFFFFFB48F},
+	{0x3C4FECBB600740D1, 0x697598CEADD71A15, 0xFFFFFFFFFFFFFA72},
+	{0x1574CC916D60E673, 0x12F5A30DD99D7051, 0xFFFFFFFFFFFFFFA1},
+	{0xDD3DCD1B9CB7321D, 0x4016ED3E05883572, 0xFFFFFFFFFFFFFFFA},
+	{0xB4A4E8CF3DF79A7A, 0xAF22D9AFAD5A73CF, 0xFFFFFFFFFFFFFFFF},
+	{0x91056A8196F74466, 0xFBF88681905332BA, 0xFFFFFFFFFFFFFFFF},
+	{0x965B9ED9BD366C04, 0xFFD16385AF29A51F, 0xFFFFFFFFFFFFFFFF},
+	{0xF05F75D38F2D28A3, 0xFFFE16FF8EA2B60C, 0xFFFFFFFFFFFFFFFF},
+	{0x77E35C8980421EE8, 0xFFFFEDD3C9DDC7E8, 0xFFFFFFFFFFFFFFFF},
+	{0x92783617956F140A, 0xFFFFFF63392B6E8F, 0xFFFFFFFFFFFFFFFF},
+	{0xA536DC994639AD78, 0xFFFFFFFB3592B3D1, 0xFFFFFFFFFFFFFFFF},
+	{0x8F3A871874DD9FD5, 0xFFFFFFFFDE04A5BB, 0xFFFFFFFFFFFFFFFF},
+	{0x310DE3650170B717, 0xFFFFFFFFFF257152, 0xFFFFFFFFFFFFFFFF},
+	{0x1F21A853A422F8CC, 0xFFFFFFFFFFFB057B, 0xFFFFFFFFFFFFFFFF},
+	{0x3CA9D5C6DB4EE2BA, 0xFFFFFFFFFFFFE5AD, 0xFFFFFFFFFFFFFFFF},
+	{0xCFD9CE958E59869C, 0xFFFFFFFFFFFFFF81, 0xFFFFFFFFFFFFFFFF},
+	{0xDB8E1F91D955C452, 0xFFFFFFFFFFFFFFFD, 0xFFFFFFFFFFFFFFFF},
+	{0xF78EE3A8E99E08C3, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFE1D7858BABDA25, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFF9E52E32CAB4A, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFEE13217574F, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFD04888041, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFFF8CD8A56, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFFFFF04111, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFFFFFFE0C5, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFFFFFFFFC7, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF},
+	{0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF}
+};
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/crypto/rlwekex/rlwekextest.c openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekextest.c
--- openssl-1.0.1f/crypto/rlwekex/rlwekextest.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.1f-rlwekex/crypto/rlwekex/rlwekextest.c	2014-10-16 12:38:19.000000000 +0200
@@ -0,0 +1,228 @@
+/* crypto/rlwekex/rlwekextest.c */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
+
+#include "../e_os.h"
+
+#include <openssl/opensslconf.h>
+#include <openssl/crypto.h>
+#include <openssl/bio.h>
+#include <openssl/bn.h>
+#include <openssl/objects.h>
+#include <openssl/rand.h>
+#include <openssl/sha.h>
+#include <openssl/err.h>
+
+#ifdef OPENSSL_NO_RLWEKEX
+int main(int argc, char *argv[]) {
+	printf("No RLWEKEX support\n");
+	return (0);
+}
+#else
+#include <openssl/rlwekex.h>
+
+#ifdef OPENSSL_SYS_WIN16
+#define MS_CALLBACK	_far _loadds
+#else
+#define MS_CALLBACK
+#endif
+
+static const char rnd_seed[] = "string to make the random number generator think it has entropy";
+
+static const int KDF1_SHA1_len = 20;
+static void *KDF1_SHA1(const void *in, size_t inlen, void *out, size_t *outlen) {
+#ifndef OPENSSL_NO_SHA
+	if (*outlen < SHA_DIGEST_LENGTH)
+		return NULL;
+	else
+		*outlen = SHA_DIGEST_LENGTH;
+	return SHA1(in, inlen, out);
+#else
+	return NULL;
+#endif
+}
+
+
+static int test_rlwekex(BIO *out, int single) {
+
+	RLWE_PAIR *alice = NULL, *bob = NULL;
+	RLWE_REC *rec = NULL;
+
+	RLWE_PUB *bob_reconstructed = NULL;
+	RLWE_REC *rec_reconstructed = NULL;
+
+	RLWE_CTX *ctx = NULL;
+
+	unsigned char *apubbuf = NULL, *bpubbuf = NULL;
+	size_t apublen, bpublen;
+
+	unsigned char *recbuf = NULL;
+	size_t reclen;
+
+	unsigned char *assbuf = NULL, *bssbuf = NULL;
+	size_t asslen, bsslen;
+
+	int i, ret = 0;
+
+	alice = RLWE_PAIR_new();
+	bob = RLWE_PAIR_new();
+	bob_reconstructed = RLWE_PUB_new();
+	rec = RLWE_REC_new();
+	rec_reconstructed = RLWE_REC_new();
+	ctx = RLWE_CTX_new ();
+	if ((alice == NULL) || (bob == NULL) || (bob_reconstructed == NULL) || (rec == NULL) || (rec_reconstructed == NULL) || (ctx == NULL)) {
+		goto err;
+	}
+
+	if (single) BIO_puts(out, "Testing key generation\n");
+
+	if (!RLWE_PAIR_generate_key(alice, ctx)) goto err;
+	apublen = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(alice), &apubbuf);
+	if (single) BIO_printf(out, "  pub_A (%i bytes) = ", (int) apublen);
+	if (apublen <= 0) {
+		fprintf(stderr, "Error in RLWEKEX routines\n");
+		ret = 0;
+		goto err;
+	}
+	if (single) {
+		for (i = 0; i < apublen; i++) {
+			BIO_printf(out, "%02X", apubbuf[i]);
+		}
+		BIO_puts(out, "\n");
+	}
+
+	if (!RLWE_PAIR_generate_key(bob, ctx)) goto err;
+	bpublen = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(bob), &bpubbuf);
+	if (single) {
+		BIO_printf(out, "\n  pub_B (%i bytes) = ", (int) bpublen);
+		for (i = 0; i < bpublen; i++) {
+			BIO_printf(out, "%02X", bpubbuf[i]);
+		}
+		BIO_puts(out, "\n");
+	}
+
+	if (single) BIO_puts(out, "Testing Bob shared secret generation\n");
+
+	bsslen = KDF1_SHA1_len;
+	bssbuf = (unsigned char *)OPENSSL_malloc(bsslen);
+	bsslen = RLWEKEX_compute_key_bob(bssbuf, bsslen, rec,
+	                                 RLWE_PAIR_get_publickey(alice), bob, KDF1_SHA1, ctx);
+	if (single) {
+		BIO_printf(out, "  key_B (%i bytes) = ", (int) bsslen);
+		for (i = 0; i < bsslen; i++) {
+			BIO_printf(out, "%02X", bssbuf[i]);
+		}
+		BIO_puts(out, "\n");
+	}
+	reclen = i2o_RLWE_REC(rec, &recbuf);
+	if (single) {
+		BIO_printf(out, "  rec (%i bytes) = ", (int) reclen);
+		for (i = 0; i < reclen; i++) {
+			BIO_printf(out, "%02X", recbuf[i]);
+		}
+		BIO_puts(out, "\n");
+	}
+
+	if (single) BIO_puts(out, "Reconstructing Bob's values\n");
+
+	if (o2i_RLWE_PUB(&bob_reconstructed, bpubbuf, bpublen) == NULL) {
+		fprintf(stderr, "Error in RLWEKEX routines (Bob public key reconstruction)\n");
+		ret = 0;
+		goto err;
+	}
+	if (o2i_RLWE_REC(&rec_reconstructed, recbuf, reclen) == NULL) {
+		fprintf(stderr, "Error in RLWEKEX routines (Bob reconciliation reconstruction)\n");
+		ret = 0;
+		goto err;
+	}
+
+	if (single) BIO_puts(out, "Testing Alice shared secret generation\n");
+
+	asslen = KDF1_SHA1_len;
+	assbuf = (unsigned char *)OPENSSL_malloc(asslen);
+	asslen = RLWEKEX_compute_key_alice(assbuf, asslen, bob_reconstructed, rec_reconstructed, alice, KDF1_SHA1, ctx);
+	if (single) {
+		BIO_printf(out, "  key_A (%i bytes) = ", (int) asslen);
+		for (i = 0; i < asslen; i++) {
+			BIO_printf(out, "%02X", assbuf[i]);
+		}
+		BIO_puts(out, "\n");
+	}
+
+	if ((bsslen != asslen) || (memcmp(assbuf, bssbuf, asslen) != 0)) {
+		BIO_printf(out, " failed\n\n");
+		fprintf(stderr, "Error in RLWEKEX routines (mismatched shared secrets)\n");
+		ret = 0;
+	} else {
+		if (single) BIO_printf(out, "ok!\n");
+		ret = 1;
+	}
+err:
+	ERR_print_errors_fp(stderr);
+
+	OPENSSL_free(bssbuf);
+	OPENSSL_free(assbuf);
+	OPENSSL_free(apubbuf);
+	OPENSSL_free(bpubbuf);
+	OPENSSL_free(recbuf);
+	RLWE_REC_free(rec_reconstructed);
+	RLWE_REC_free(rec);
+	RLWE_PUB_free(bob_reconstructed);
+	RLWE_PAIR_free(bob);
+	RLWE_PAIR_free(alice);
+	RLWE_CTX_free(ctx);
+	return (ret);
+}
+
+int main(int argc, char *argv[]) {
+	int ret = 1;
+	BIO *out;
+
+	CRYPTO_malloc_debug_init();
+	CRYPTO_dbg_set_options(V_CRYPTO_MDEBUG_ALL);
+	CRYPTO_mem_ctrl(CRYPTO_MEM_CHECK_ON);
+
+#ifdef OPENSSL_SYS_WIN32
+	CRYPTO_malloc_init();
+#endif
+
+	RAND_seed(rnd_seed, sizeof rnd_seed);
+
+	out = BIO_new(BIO_s_file());
+	if (out == NULL) EXIT(1);
+	BIO_set_fp(out, stdout, BIO_NOCLOSE);
+
+	if (argc == 1) {
+		if (!test_rlwekex(out, 1)) goto err;
+	} else {
+		int iterations = 0;
+		int failures = 0;
+		time_t starttime = time(NULL);
+		while (1) {
+			iterations++;
+			if (test_rlwekex(out, 0) == 1) {
+			} else {
+				failures++;
+			}
+			if ((iterations % 100) == 0) {
+				BIO_printf(out, "Iterations: %d, failures: %d, elapsed time: %ld\n", iterations, failures, time(NULL) - starttime);
+			}
+		}
+	}
+
+	ret = 0;
+
+err:
+	ERR_print_errors_fp(stderr);
+	BIO_free(out);
+	CRYPTO_cleanup_all_ex_data();
+	ERR_remove_thread_state(NULL);
+	CRYPTO_mem_leaks_fp(stderr);
+	EXIT(ret);
+	return (ret);
+}
+
+#endif
